<%
/**
 * Copyright (c) 2000-2009 Liferay, Inc. All rights reserved.
 *
 *
 *
 *
 * The contents of this file are subject to the terms of the Liferay Enterprise
 * Subscription License ("License"). You may not use this file except in
 * compliance with the License. You can obtain a copy of the License by
 * contacting Liferay, Inc. See the License for the specific language governing
 * permissions and limitations under the License, including but not limited to
 * distribution rights of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */
%>

<%@ include file="/html/portlet/enterprise_admin/init.jsp" %>

<%
User user2 = (User)request.getAttribute("edit_user.jsp-user2");

String sectionRedirectParams = (String)request.getAttribute("edit_user.jsp-sectionRedirectParams");

List groups = GroupLocalServiceUtil.getUserGroups(user2.getUserId());

SearchContainer searchContainer = new SearchContainer();

List<String> headerNames = new ArrayList<String>();

headerNames.add("name");
headerNames.add("community");

if (user2.getUserId() != user.getUserId()) {
	headerNames.add(StringPool.BLANK);
}

searchContainer.setHeaderNames(headerNames);

if (user2.getUserId() == user.getUserId()) {
	searchContainer.setEmptyResultsMessage("you-do-not-have-any-community-roles");
}
else {
	searchContainer.setEmptyResultsMessage("the-user-does-not-have-any-community-roles");
}

List results = new ArrayList();
List resultRows = searchContainer.getResultRows();

for (int i = 0; i < groups.size(); i++) {
	Group group = (Group)groups.get(i);

	List userGroupRoles = UserGroupRoleLocalServiceUtil.getUserGroupRoles(user2.getUserId(), group.getGroupId());

	for (int j = 0; j < userGroupRoles.size(); j++) {
		UserGroupRole userGroupRole = (UserGroupRole)userGroupRoles.get(j);

		Role role = RoleLocalServiceUtil.getRole(userGroupRole.getRoleId());

		ResultRow row = new ResultRow(new Object[] {user2, group, role, currentURL + sectionRedirectParams}, role.getRoleId(), j);

		// Name

		row.addText(HtmlUtil.escape(role.getName()));

		// Community

		row.addText(group.getName());

		// Action

		if (user2.getUserId() != user.getUserId()) {
			row.addJSP("right", SearchEntry.DEFAULT_VALIGN, "/html/portlet/enterprise_admin/user_group_role_action.jsp");
		}

		// Add result row

		resultRows.add(row);
		results.add(userGroupRole);
	}
}
%>

<liferay-ui:search-iterator searchContainer="<%= searchContainer %>" />

<br />